<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'HelloWorld' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\HelloWorld',
            'RetailContext' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\RetailContext',
            'HelloWorldResponse' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\HelloWorldResponse',
            'GetCustomerIdByReference' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\GetCustomerIdByReference',
            'GetCustomerIdByReferenceResponse' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\GetCustomerIdByReferenceResponse',
            'GetCustomerDetail' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\GetCustomerDetail',
            'GetCustomerDetailResponse' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\GetCustomerDetailResponse',
            'CustomerQueryData' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\CustomerQueryData',
            'CustomerData' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\CustomerData',
            'CustomerDataBase' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\CustomerDataBase',
            'AddressDataType' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\AddressDataType',
            'EmailDataType' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\EmailDataType',
            'PhoneDataType' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\PhoneDataType',
            'ArrayOfUserDefinedBoolean' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\ArrayType\\ArrayOfUserDefinedBoolean',
            'UserDefinedBoolean' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\UserDefinedBoolean',
            'UserDefinedDataType' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\UserDefinedDataType',
            'ArrayOfUserDefinedDate' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\ArrayType\\ArrayOfUserDefinedDate',
            'UserDefinedDate' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\UserDefinedDate',
            'ArrayOfUserDefinedText' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\ArrayType\\ArrayOfUserDefinedText',
            'UserDefinedText' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\UserDefinedText',
            'ArrayOfUserDefinedValue' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\ArrayType\\ArrayOfUserDefinedValue',
            'UserDefinedValue' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\UserDefinedValue',
            'BirthDateDataType' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\BirthDateDataType',
            'ArrayOfUserField' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\ArrayType\\ArrayOfUserField',
            'UserField' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\UserField',
            'SearchCustomerIds' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\SearchCustomerIds',
            'CustomerSearchDataType' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\CustomerSearchDataType',
            'NationalityDataType' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\NationalityDataType',
            'SearchCustomerIdsResponse' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\SearchCustomerIdsResponse',
            'ArrayOfCustomerQueryData' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\ArrayType\\ArrayOfCustomerQueryData',
            'AddNewCustomer' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\AddNewCustomer',
            'CustomerInsertData' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\CustomerInsertData',
            'CustomerInputData' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\CustomerInputData',
            'InternalGuid' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\InternalGuid',
            'AddNewCustomerResponse' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\AddNewCustomerResponse',
            'UpdateCustomer' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\UpdateCustomer',
            'UpdateCustomerResponse' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\UpdateCustomerResponse',
            'CbpFaultDetail' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\CbpFaultDetail',
            'BusinessFaultDetail' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\BusinessFaultDetail',
            'ExceptionDetail' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\ExceptionDetail',
            'CbpExceptionDetail' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\StructType\\CbpExceptionDetail',
            'ArrayOfstring' => '\\FiloBlu\\CegidY2\\Api\\CustomerWcfService\\ArrayType\\ArrayOfstring',
        );
    }
}
