<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmailDataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Emails du client.
 * - nillable: true
 * - type: q22:EmailDataType
 * @subpackage Structs
 */
class EmailDataType extends AbstractStructBase
{
    /**
     * The AlternativeEmail
     * Meta information extracted from the WSDL
     * - documentation: Email secondaire du client. - Relatif à la colonne [TIERS.T_EMAIL2].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AlternativeEmail;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - documentation: Email du client. - Relatif à la colonne [TIERS.T_EMAIL].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Email;
    /**
     * The EmailingAccepted
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Propriété indiquant si le client accepte ou pas de recevoir des mails. - Relatif à la colonne [TIERS.T_EMAILING].
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $EmailingAccepted;
    /**
     * The SendReceiptByMail
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Acceptation du client pour l'envoi des tickets par mail - Relatif à la colonne [TIERSCOMPL.YTC_ENVTICKEMAIL].
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $SendReceiptByMail;
    /**
     * Constructor method for EmailDataType
     * @uses EmailDataType::setAlternativeEmail()
     * @uses EmailDataType::setEmail()
     * @uses EmailDataType::setEmailingAccepted()
     * @uses EmailDataType::setSendReceiptByMail()
     * @param string $alternativeEmail
     * @param string $email
     * @param bool $emailingAccepted
     * @param bool $sendReceiptByMail
     */
    public function __construct($alternativeEmail = null, $email = null, $emailingAccepted = null, $sendReceiptByMail = null)
    {
        $this
            ->setAlternativeEmail($alternativeEmail)
            ->setEmail($email)
            ->setEmailingAccepted($emailingAccepted)
            ->setSendReceiptByMail($sendReceiptByMail);
    }
    /**
     * Get AlternativeEmail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAlternativeEmail()
    {
        return isset($this->AlternativeEmail) ? $this->AlternativeEmail : null;
    }
    /**
     * Set AlternativeEmail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $alternativeEmail
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\EmailDataType
     */
    public function setAlternativeEmail($alternativeEmail = null)
    {
        // validation for constraint: string
        if (!is_null($alternativeEmail) && !is_string($alternativeEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($alternativeEmail, true), gettype($alternativeEmail)), __LINE__);
        }
        if (is_null($alternativeEmail) || (is_array($alternativeEmail) && empty($alternativeEmail))) {
            unset($this->AlternativeEmail);
        } else {
            $this->AlternativeEmail = $alternativeEmail;
        }
        return $this;
    }
    /**
     * Get Email value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEmail()
    {
        return isset($this->Email) ? $this->Email : null;
    }
    /**
     * Set Email value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $email
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\EmailDataType
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($email, true), gettype($email)), __LINE__);
        }
        if (is_null($email) || (is_array($email) && empty($email))) {
            unset($this->Email);
        } else {
            $this->Email = $email;
        }
        return $this;
    }
    /**
     * Get EmailingAccepted value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getEmailingAccepted()
    {
        return isset($this->EmailingAccepted) ? $this->EmailingAccepted : null;
    }
    /**
     * Set EmailingAccepted value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $emailingAccepted
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\EmailDataType
     */
    public function setEmailingAccepted($emailingAccepted = null)
    {
        // validation for constraint: boolean
        if (!is_null($emailingAccepted) && !is_bool($emailingAccepted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($emailingAccepted, true), gettype($emailingAccepted)), __LINE__);
        }
        if (is_null($emailingAccepted) || (is_array($emailingAccepted) && empty($emailingAccepted))) {
            unset($this->EmailingAccepted);
        } else {
            $this->EmailingAccepted = $emailingAccepted;
        }
        return $this;
    }
    /**
     * Get SendReceiptByMail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getSendReceiptByMail()
    {
        return isset($this->SendReceiptByMail) ? $this->SendReceiptByMail : null;
    }
    /**
     * Set SendReceiptByMail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $sendReceiptByMail
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\EmailDataType
     */
    public function setSendReceiptByMail($sendReceiptByMail = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendReceiptByMail) && !is_bool($sendReceiptByMail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sendReceiptByMail, true), gettype($sendReceiptByMail)), __LINE__);
        }
        if (is_null($sendReceiptByMail) || (is_array($sendReceiptByMail) && empty($sendReceiptByMail))) {
            unset($this->SendReceiptByMail);
        } else {
            $this->SendReceiptByMail = $sendReceiptByMail;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\EmailDataType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
