<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetAvailableCumulativeQtyAllStores StructType
 * Meta information extracted from the WSDL
 * - documentation: Renvoie le cumul des quantités disponibles en stock de tous les établissements accessibles à l’utilisateur courant.
 * @subpackage Structs
 */
class GetAvailableCumulativeQtyAllStores extends AbstractStructBase
{
    /**
     * The itemId
     * Meta information extracted from the WSDL
     * - documentation: [Obsolète] - Référence à utiliser pour déterminer l’article dont le cumul tout établissement doit être retourné.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $itemId;
    /**
     * The itemIdentifier
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1104] [Optionnel] - Comportement par defaut: Cette propriété remplacera à terme [itemId] qui deviendra obsolète avant d'être supprimée
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier
     */
    public $itemIdentifier;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for GetAvailableCumulativeQtyAllStores
     * @uses GetAvailableCumulativeQtyAllStores::setItemId()
     * @uses GetAvailableCumulativeQtyAllStores::setItemIdentifier()
     * @uses GetAvailableCumulativeQtyAllStores::setClientContext()
     * @param string $itemId
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext
     */
    public function __construct($itemId = null, \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier = null, \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setItemId($itemId)
            ->setItemIdentifier($itemIdentifier)
            ->setClientContext($clientContext);
    }
    /**
     * Get itemId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getItemId()
    {
        return isset($this->itemId) ? $this->itemId : null;
    }
    /**
     * Set itemId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $itemId
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStores
     */
    public function setItemId($itemId = null)
    {
        // validation for constraint: string
        if (!is_null($itemId) && !is_string($itemId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($itemId, true), gettype($itemId)), __LINE__);
        }
        if (is_null($itemId) || (is_array($itemId) && empty($itemId))) {
            unset($this->itemId);
        } else {
            $this->itemId = $itemId;
        }
        return $this;
    }
    /**
     * Get itemIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier|null
     */
    public function getItemIdentifier()
    {
        return isset($this->itemIdentifier) ? $this->itemIdentifier : null;
    }
    /**
     * Set itemIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStores
     */
    public function setItemIdentifier(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier = null)
    {
        if (is_null($itemIdentifier) || (is_array($itemIdentifier) && empty($itemIdentifier))) {
            unset($this->itemIdentifier);
        } else {
            $this->itemIdentifier = $itemIdentifier;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStores
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStores
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
