<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetAvailableQty StructType
 * Meta information extracted from the WSDL
 * - documentation: Renvoie la quantité disponible en stock pour un article sans dimension ou SKU.
 * @subpackage Structs
 */
class GetAvailableQty extends AbstractStructBase
{
    /**
     * The itemId
     * Meta information extracted from the WSDL
     * - documentation: [Obsolète] - Référence de l’article - utilise les priorités de recherche article
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $itemId;
    /**
     * The itemIdentifier
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1104] [Optionnel] - Comportement par defaut: Cette propriété remplacera à terme [itemId] qui deviendra obsolète avant d'être supprimée
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier
     */
    public $itemIdentifier;
    /**
     * The storeId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/11 - V1104] [Optionnel] - Identifiant de l'établissement utilisé. - Comportement par defaut: Si le dépôt [warehouseId] n'est pas précisé, c'est le dépôt le plus prioritaire qui est utilisé - Relatif à la
     * colonne [ETABLISS.ET_ETABLISSEMENT]
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $storeId;
    /**
     * The warehouseId
     * Meta information extracted from the WSDL
     * - documentation: [Obsolète] [Optionnel] - Identifiant du dépôt utilisé. - Comportement par defaut: Utilise le dépôt par défaut de l'utilisateur - Relatif à la colonne [DEPOT.GDE_DEPOT]
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $warehouseId;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for GetAvailableQty
     * @uses GetAvailableQty::setItemId()
     * @uses GetAvailableQty::setItemIdentifier()
     * @uses GetAvailableQty::setStoreId()
     * @uses GetAvailableQty::setWarehouseId()
     * @uses GetAvailableQty::setClientContext()
     * @param string $itemId
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier
     * @param string $storeId
     * @param string $warehouseId
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext
     */
    public function __construct($itemId = null, \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier = null, $storeId = null, $warehouseId = null, \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setItemId($itemId)
            ->setItemIdentifier($itemIdentifier)
            ->setStoreId($storeId)
            ->setWarehouseId($warehouseId)
            ->setClientContext($clientContext);
    }
    /**
     * Get itemId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getItemId()
    {
        return isset($this->itemId) ? $this->itemId : null;
    }
    /**
     * Set itemId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $itemId
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQty
     */
    public function setItemId($itemId = null)
    {
        // validation for constraint: string
        if (!is_null($itemId) && !is_string($itemId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($itemId, true), gettype($itemId)), __LINE__);
        }
        if (is_null($itemId) || (is_array($itemId) && empty($itemId))) {
            unset($this->itemId);
        } else {
            $this->itemId = $itemId;
        }
        return $this;
    }
    /**
     * Get itemIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier|null
     */
    public function getItemIdentifier()
    {
        return isset($this->itemIdentifier) ? $this->itemIdentifier : null;
    }
    /**
     * Set itemIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQty
     */
    public function setItemIdentifier(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier = null)
    {
        if (is_null($itemIdentifier) || (is_array($itemIdentifier) && empty($itemIdentifier))) {
            unset($this->itemIdentifier);
        } else {
            $this->itemIdentifier = $itemIdentifier;
        }
        return $this;
    }
    /**
     * Get storeId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStoreId()
    {
        return isset($this->storeId) ? $this->storeId : null;
    }
    /**
     * Set storeId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $storeId
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQty
     */
    public function setStoreId($storeId = null)
    {
        // validation for constraint: string
        if (!is_null($storeId) && !is_string($storeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($storeId, true), gettype($storeId)), __LINE__);
        }
        if (is_null($storeId) || (is_array($storeId) && empty($storeId))) {
            unset($this->storeId);
        } else {
            $this->storeId = $storeId;
        }
        return $this;
    }
    /**
     * Get warehouseId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWarehouseId()
    {
        return isset($this->warehouseId) ? $this->warehouseId : null;
    }
    /**
     * Set warehouseId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $warehouseId
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQty
     */
    public function setWarehouseId($warehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($warehouseId) && !is_string($warehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($warehouseId, true), gettype($warehouseId)), __LINE__);
        }
        if (is_null($warehouseId) || (is_array($warehouseId) && empty($warehouseId))) {
            unset($this->warehouseId);
        } else {
            $this->warehouseId = $warehouseId;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQty
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQty
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
