<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResetShoppingCart StructType
 * Meta information extracted from the WSDL
 * - documentation: [Ajouté 2013/08 - V1105] - Permet la remise à zéro de la quantité "panier web" d'un article pour un dépôt donné. Si aucun article n'est précisé, on remet a zéro la quantité pour tout le dépôt.
 * @subpackage Structs
 */
class ResetShoppingCart extends AbstractStructBase
{
    /**
     * The request
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart_Request
     */
    public $request;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for ResetShoppingCart
     * @uses ResetShoppingCart::setRequest()
     * @uses ResetShoppingCart::setClientContext()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart_Request $request
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart_Request $request = null, \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setRequest($request)
            ->setClientContext($clientContext);
    }
    /**
     * Get request value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart_Request|null
     */
    public function getRequest()
    {
        return isset($this->request) ? $this->request : null;
    }
    /**
     * Set request value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart_Request $request
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart
     */
    public function setRequest(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart_Request $request = null)
    {
        if (is_null($request) || (is_array($request) && empty($request))) {
            unset($this->request);
        } else {
            $this->request = $request;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
