<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType;

/**
 * This class stands for UpdatePointsLineType EnumType
 * Meta information extracted from the WSDL
 * - documentation: Line type
 * - nillable: true
 * - type: tns:UpdatePointsLineType
 * @subpackage Enumerations
 */
class UpdatePointsLineType
{
    /**
     * Constant for value 'Amount'
     * Meta information extracted from the WSDL
     * - documentation: Manual entry.
     * @return string 'Amount'
     */
    const VALUE_AMOUNT = 'Amount';
    /**
     * Constant for value 'CardBalance'
     * Meta information extracted from the WSDL
     * - documentation: CAPM recovery.
     * @return string 'CardBalance'
     */
    const VALUE_CARD_BALANCE = 'CardBalance';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_AMOUNT
     * @uses self::VALUE_CARD_BALANCE
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_AMOUNT,
            self::VALUE_CARD_BALANCE,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
