<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Hello ServiceType
 * @subpackage Services
 */
class Hello extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named HelloWorld
     * Meta information extracted from the WSDL
     * - documentation: HelloWorld method to validate the access to Web Services from every very light HTTP client via Javascript for example | Text to pass to test consumption. | Returns the text typed upon entry, concatenated with phrase 'Hello You'
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\HelloWorld $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\HelloWorldResponse|bool
     */
    public function HelloWorld(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\HelloWorld $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->HelloWorld($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\HelloWorldResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
