<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCustomerAvailableLoyaltyPointsResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Returns the customer's available loyalty points.
 * @subpackage Structs
 */
class GetCustomerAvailableLoyaltyPointsResponse extends AbstractStructBase
{
    /**
     * The GetCustomerAvailableLoyaltyPointsResult
     * Meta information extracted from the WSDL
     * - documentation: Returns the available loyalty points for the customer found.
     * - minOccurs: 0
     * @var float
     */
    public $GetCustomerAvailableLoyaltyPointsResult;
    /**
     * Constructor method for GetCustomerAvailableLoyaltyPointsResponse
     * @uses GetCustomerAvailableLoyaltyPointsResponse::setGetCustomerAvailableLoyaltyPointsResult()
     * @param float $getCustomerAvailableLoyaltyPointsResult
     */
    public function __construct($getCustomerAvailableLoyaltyPointsResult = null)
    {
        $this
            ->setGetCustomerAvailableLoyaltyPointsResult($getCustomerAvailableLoyaltyPointsResult);
    }
    /**
     * Get GetCustomerAvailableLoyaltyPointsResult value
     * @return float|null
     */
    public function getGetCustomerAvailableLoyaltyPointsResult()
    {
        return $this->GetCustomerAvailableLoyaltyPointsResult;
    }
    /**
     * Set GetCustomerAvailableLoyaltyPointsResult value
     * @param float $getCustomerAvailableLoyaltyPointsResult
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerAvailableLoyaltyPointsResponse
     */
    public function setGetCustomerAvailableLoyaltyPointsResult($getCustomerAvailableLoyaltyPointsResult = null)
    {
        // validation for constraint: float
        if (!is_null($getCustomerAvailableLoyaltyPointsResult) && !(is_float($getCustomerAvailableLoyaltyPointsResult) || is_numeric($getCustomerAvailableLoyaltyPointsResult))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($getCustomerAvailableLoyaltyPointsResult, true), gettype($getCustomerAvailableLoyaltyPointsResult)), __LINE__);
        }
        $this->GetCustomerAvailableLoyaltyPointsResult = $getCustomerAvailableLoyaltyPointsResult;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerAvailableLoyaltyPointsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
