<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomersReservationCreate_Line ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCustomersReservationCreate_Line
 * @subpackage Arrays
 */
class ArrayOfCustomersReservationCreate_Line extends AbstractStructArrayBase
{
    /**
     * The CustomersReservationCreate_Line
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line[]
     */
    public $CustomersReservationCreate_Line;
    /**
     * Constructor method for ArrayOfCustomersReservationCreate_Line
     * @uses ArrayOfCustomersReservationCreate_Line::setCustomersReservationCreate_Line()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line[] $customersReservationCreate_Line
     */
    public function __construct(array $customersReservationCreate_Line = array())
    {
        $this
            ->setCustomersReservationCreate_Line($customersReservationCreate_Line);
    }
    /**
     * Get CustomersReservationCreate_Line value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line[]|null
     */
    public function getCustomersReservationCreate_Line()
    {
        return isset($this->CustomersReservationCreate_Line) ? $this->CustomersReservationCreate_Line : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomersReservationCreate_Line method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomersReservationCreate_Line method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomersReservationCreate_LineForArrayConstraintsFromSetCustomersReservationCreate_Line(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomersReservationCreate_LineCustomersReservationCreate_LineItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomersReservationCreate_LineCustomersReservationCreate_LineItem instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line) {
                $invalidValues[] = is_object($arrayOfCustomersReservationCreate_LineCustomersReservationCreate_LineItem) ? get_class($arrayOfCustomersReservationCreate_LineCustomersReservationCreate_LineItem) : sprintf('%s(%s)', gettype($arrayOfCustomersReservationCreate_LineCustomersReservationCreate_LineItem), var_export($arrayOfCustomersReservationCreate_LineCustomersReservationCreate_LineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomersReservationCreate_Line property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomersReservationCreate_Line value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line[] $customersReservationCreate_Line
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCustomersReservationCreate_Line
     */
    public function setCustomersReservationCreate_Line(array $customersReservationCreate_Line = array())
    {
        // validation for constraint: array
        if ('' !== ($customersReservationCreate_LineArrayErrorMessage = self::validateCustomersReservationCreate_LineForArrayConstraintsFromSetCustomersReservationCreate_Line($customersReservationCreate_Line))) {
            throw new \InvalidArgumentException($customersReservationCreate_LineArrayErrorMessage, __LINE__);
        }
        if (is_null($customersReservationCreate_Line) || (is_array($customersReservationCreate_Line) && empty($customersReservationCreate_Line))) {
            unset($this->CustomersReservationCreate_Line);
        } else {
            $this->CustomersReservationCreate_Line = $customersReservationCreate_Line;
        }
        return $this;
    }
    /**
     * Add item to CustomersReservationCreate_Line value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line $item
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCustomersReservationCreate_Line
     */
    public function addToCustomersReservationCreate_Line(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line) {
            throw new \InvalidArgumentException(sprintf('The CustomersReservationCreate_Line property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomersReservationCreate_Line[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomersReservationCreate_Line
     */
    public function getAttributeName()
    {
        return 'CustomersReservationCreate_Line';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCustomersReservationCreate_Line
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
