<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGet_Header ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGet_Header
 * @subpackage Arrays
 */
class ArrayOfGet_Header extends AbstractStructArrayBase
{
    /**
     * The Get_Header
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header[]
     */
    public $Get_Header;
    /**
     * Constructor method for ArrayOfGet_Header
     * @uses ArrayOfGet_Header::setGet_Header()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header[] $get_Header
     */
    public function __construct(array $get_Header = array())
    {
        $this
            ->setGet_Header($get_Header);
    }
    /**
     * Get Get_Header value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header[]|null
     */
    public function getGet_Header()
    {
        return isset($this->Get_Header) ? $this->Get_Header : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGet_Header method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGet_Header method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGet_HeaderForArrayConstraintsFromSetGet_Header(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGet_HeaderGet_HeaderItem) {
            // validation for constraint: itemType
            if (!$arrayOfGet_HeaderGet_HeaderItem instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header) {
                $invalidValues[] = is_object($arrayOfGet_HeaderGet_HeaderItem) ? get_class($arrayOfGet_HeaderGet_HeaderItem) : sprintf('%s(%s)', gettype($arrayOfGet_HeaderGet_HeaderItem), var_export($arrayOfGet_HeaderGet_HeaderItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Get_Header property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Get_Header value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header[] $get_Header
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfGet_Header
     */
    public function setGet_Header(array $get_Header = array())
    {
        // validation for constraint: array
        if ('' !== ($get_HeaderArrayErrorMessage = self::validateGet_HeaderForArrayConstraintsFromSetGet_Header($get_Header))) {
            throw new \InvalidArgumentException($get_HeaderArrayErrorMessage, __LINE__);
        }
        if (is_null($get_Header) || (is_array($get_Header) && empty($get_Header))) {
            unset($this->Get_Header);
        } else {
            $this->Get_Header = $get_Header;
        }
        return $this;
    }
    /**
     * Add item to Get_Header value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header $item
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfGet_Header
     */
    public function addToGet_Header(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header) {
            throw new \InvalidArgumentException(sprintf('The Get_Header property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Get_Header[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Get_Header
     */
    public function getAttributeName()
    {
        return 'Get_Header';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfGet_Header
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
