<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUpdate_Tax ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUpdate_Tax
 * @subpackage Arrays
 */
class ArrayOfUpdate_Tax extends AbstractStructArrayBase
{
    /**
     * The Update_Tax
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax[]
     */
    public $Update_Tax;
    /**
     * Constructor method for ArrayOfUpdate_Tax
     * @uses ArrayOfUpdate_Tax::setUpdate_Tax()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax[] $update_Tax
     */
    public function __construct(array $update_Tax = array())
    {
        $this
            ->setUpdate_Tax($update_Tax);
    }
    /**
     * Get Update_Tax value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax[]|null
     */
    public function getUpdate_Tax()
    {
        return isset($this->Update_Tax) ? $this->Update_Tax : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUpdate_Tax method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpdate_Tax method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpdate_TaxForArrayConstraintsFromSetUpdate_Tax(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUpdate_TaxUpdate_TaxItem) {
            // validation for constraint: itemType
            if (!$arrayOfUpdate_TaxUpdate_TaxItem instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax) {
                $invalidValues[] = is_object($arrayOfUpdate_TaxUpdate_TaxItem) ? get_class($arrayOfUpdate_TaxUpdate_TaxItem) : sprintf('%s(%s)', gettype($arrayOfUpdate_TaxUpdate_TaxItem), var_export($arrayOfUpdate_TaxUpdate_TaxItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Update_Tax property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Update_Tax value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax[] $update_Tax
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Tax
     */
    public function setUpdate_Tax(array $update_Tax = array())
    {
        // validation for constraint: array
        if ('' !== ($update_TaxArrayErrorMessage = self::validateUpdate_TaxForArrayConstraintsFromSetUpdate_Tax($update_Tax))) {
            throw new \InvalidArgumentException($update_TaxArrayErrorMessage, __LINE__);
        }
        if (is_null($update_Tax) || (is_array($update_Tax) && empty($update_Tax))) {
            unset($this->Update_Tax);
        } else {
            $this->Update_Tax = $update_Tax;
        }
        return $this;
    }
    /**
     * Add item to Update_Tax value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax $item
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Tax
     */
    public function addToUpdate_Tax(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax) {
            throw new \InvalidArgumentException(sprintf('The Update_Tax property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Update_Tax[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Update_Tax
     */
    public function getAttributeName()
    {
        return 'Update_Tax';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Tax
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
