<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\EnumType;

/**
 * This class stands for OrderReturnStatus EnumType
 * Meta information extracted from the WSDL
 * - documentation: e-Commerce return status
 * - nillable: true
 * - type: tns:OrderReturnStatus
 * @subpackage Enumerations
 */
class OrderReturnStatus
{
    /**
     * Constant for value 'NotReturned'
     * Meta information extracted from the WSDL
     * - documentation: Not returned.
     * @return string 'NotReturned'
     */
    const VALUE_NOT_RETURNED = 'NotReturned';
    /**
     * Constant for value 'Returned'
     * Meta information extracted from the WSDL
     * - documentation: Returned.
     * @return string 'Returned'
     */
    const VALUE_RETURNED = 'Returned';
    /**
     * Constant for value 'PartlyReturned'
     * Meta information extracted from the WSDL
     * - documentation: Partially returned.
     * @return string 'PartlyReturned'
     */
    const VALUE_PARTLY_RETURNED = 'PartlyReturned';
    /**
     * Constant for value 'ReturnPlanned'
     * Meta information extracted from the WSDL
     * - documentation: Announced return.
     * @return string 'ReturnPlanned'
     */
    const VALUE_RETURN_PLANNED = 'ReturnPlanned';
    /**
     * Constant for value 'ReturnAccepted'
     * Meta information extracted from the WSDL
     * - documentation: Return accepted.
     * @return string 'ReturnAccepted'
     */
    const VALUE_RETURN_ACCEPTED = 'ReturnAccepted';
    /**
     * Constant for value 'ReturnRefused'
     * Meta information extracted from the WSDL
     * - documentation: Return refused.
     * @return string 'ReturnRefused'
     */
    const VALUE_RETURN_REFUSED = 'ReturnRefused';
    /**
     * Constant for value 'ReturnPartlyAccepted'
     * Meta information extracted from the WSDL
     * - documentation: Return partially accepted.
     * @return string 'ReturnPartlyAccepted'
     */
    const VALUE_RETURN_PARTLY_ACCEPTED = 'ReturnPartlyAccepted';
    /**
     * Constant for value 'ReturnValidated'
     * Meta information extracted from the WSDL
     * - documentation: Return validated.
     * @return string 'ReturnValidated'
     */
    const VALUE_RETURN_VALIDATED = 'ReturnValidated';
    /**
     * Constant for value 'ReturnNotValidated'
     * Meta information extracted from the WSDL
     * - documentation: Return not validated.
     * @return string 'ReturnNotValidated'
     */
    const VALUE_RETURN_NOT_VALIDATED = 'ReturnNotValidated';
    /**
     * Constant for value 'ReturnPartlyValidated'
     * Meta information extracted from the WSDL
     * - documentation: Return partially validated.
     * @return string 'ReturnPartlyValidated'
     */
    const VALUE_RETURN_PARTLY_VALIDATED = 'ReturnPartlyValidated';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_NOT_RETURNED
     * @uses self::VALUE_RETURNED
     * @uses self::VALUE_PARTLY_RETURNED
     * @uses self::VALUE_RETURN_PLANNED
     * @uses self::VALUE_RETURN_ACCEPTED
     * @uses self::VALUE_RETURN_REFUSED
     * @uses self::VALUE_RETURN_PARTLY_ACCEPTED
     * @uses self::VALUE_RETURN_VALIDATED
     * @uses self::VALUE_RETURN_NOT_VALIDATED
     * @uses self::VALUE_RETURN_PARTLY_VALIDATED
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_NOT_RETURNED,
            self::VALUE_RETURNED,
            self::VALUE_PARTLY_RETURNED,
            self::VALUE_RETURN_PLANNED,
            self::VALUE_RETURN_ACCEPTED,
            self::VALUE_RETURN_REFUSED,
            self::VALUE_RETURN_PARTLY_ACCEPTED,
            self::VALUE_RETURN_VALIDATED,
            self::VALUE_RETURN_NOT_VALIDATED,
            self::VALUE_RETURN_PARTLY_VALIDATED,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
