<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Get ServiceType
 * @subpackage Services
 */
class Get extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named GetHeaderList
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/04 - V1102] - Gets the list of sales history (header) for a customer. The list is sorted by decreasing dates. The 'Customer's sales query' restriction applies to the calculation of this sales history.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderListResponse|bool
     */
    public function GetHeaderList(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetHeaderList($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetByKey
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/04 - V1102] - Gets a sales document based on its unique key. | Returns the sales document.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKeyResponse|bool
     */
    public function GetByKey(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetByKey($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetByReference
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/04 - V1102] - Gets a sales document based its customer reference.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByReference $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByReferenceResponse|bool
     */
    public function GetByReference(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByReference $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetByReference($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetByExternalReference
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/04 - V1102] - Gets a list of sales documents based on an external reference.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByExternalReference $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByExternalReferenceResponse|bool
     */
    public function GetByExternalReference(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByExternalReference $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetByExternalReference($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByExternalReferenceResponse|\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKeyResponse|\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByReferenceResponse|\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderListResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
