<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_ShippingTax StructType
 * Meta information extracted from the WSDL
 * - documentation: Shipping fees.
 * - nillable: true
 * - type: tns:Get_ShippingTax
 * @subpackage Structs
 */
class Get_ShippingTax extends AbstractStructBase
{
    /**
     * The ShippingTaxCode
     * Meta information extracted from the WSDL
     * - documentation: Shipping fee code. - Related to column [PIEDPORT.GPT_CODEPORT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ShippingTaxCode;
    /**
     * The TaxExcludedAmount
     * Meta information extracted from the WSDL
     * - documentation: Tax excl. shipping fee amount. - Related to column [PIEDPORT.GPT_TOTALHT].
     * - minOccurs: 0
     * @var float
     */
    public $TaxExcludedAmount;
    /**
     * The TaxIncludedAmount
     * Meta information extracted from the WSDL
     * - documentation: Tax incl. shipping fee amount. - Related to column [PIEDPORT.GPT_TOTALTTC].
     * - minOccurs: 0
     * @var float
     */
    public $TaxIncludedAmount;
    /**
     * Constructor method for Get_ShippingTax
     * @uses Get_ShippingTax::setShippingTaxCode()
     * @uses Get_ShippingTax::setTaxExcludedAmount()
     * @uses Get_ShippingTax::setTaxIncludedAmount()
     * @param string $shippingTaxCode
     * @param float $taxExcludedAmount
     * @param float $taxIncludedAmount
     */
    public function __construct($shippingTaxCode = null, $taxExcludedAmount = null, $taxIncludedAmount = null)
    {
        $this
            ->setShippingTaxCode($shippingTaxCode)
            ->setTaxExcludedAmount($taxExcludedAmount)
            ->setTaxIncludedAmount($taxIncludedAmount);
    }
    /**
     * Get ShippingTaxCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getShippingTaxCode()
    {
        return isset($this->ShippingTaxCode) ? $this->ShippingTaxCode : null;
    }
    /**
     * Set ShippingTaxCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $shippingTaxCode
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_ShippingTax
     */
    public function setShippingTaxCode($shippingTaxCode = null)
    {
        // validation for constraint: string
        if (!is_null($shippingTaxCode) && !is_string($shippingTaxCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shippingTaxCode, true), gettype($shippingTaxCode)), __LINE__);
        }
        if (is_null($shippingTaxCode) || (is_array($shippingTaxCode) && empty($shippingTaxCode))) {
            unset($this->ShippingTaxCode);
        } else {
            $this->ShippingTaxCode = $shippingTaxCode;
        }
        return $this;
    }
    /**
     * Get TaxExcludedAmount value
     * @return float|null
     */
    public function getTaxExcludedAmount()
    {
        return $this->TaxExcludedAmount;
    }
    /**
     * Set TaxExcludedAmount value
     * @param float $taxExcludedAmount
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_ShippingTax
     */
    public function setTaxExcludedAmount($taxExcludedAmount = null)
    {
        // validation for constraint: float
        if (!is_null($taxExcludedAmount) && !(is_float($taxExcludedAmount) || is_numeric($taxExcludedAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($taxExcludedAmount, true), gettype($taxExcludedAmount)), __LINE__);
        }
        $this->TaxExcludedAmount = $taxExcludedAmount;
        return $this;
    }
    /**
     * Get TaxIncludedAmount value
     * @return float|null
     */
    public function getTaxIncludedAmount()
    {
        return $this->TaxIncludedAmount;
    }
    /**
     * Set TaxIncludedAmount value
     * @param float $taxIncludedAmount
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_ShippingTax
     */
    public function setTaxIncludedAmount($taxIncludedAmount = null)
    {
        // validation for constraint: float
        if (!is_null($taxIncludedAmount) && !(is_float($taxIncludedAmount) || is_numeric($taxIncludedAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($taxIncludedAmount, true), gettype($taxIncludedAmount)), __LINE__);
        }
        $this->TaxIncludedAmount = $taxIncludedAmount;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_ShippingTax
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
